//Homerun Bat
//The datablock spacing doesn't look hideous now. Yay.

//Audio Datablocks
//Sound for the normal hit.
datablock AudioProfile(HomerunBatHitSound)
{
	filename		= "./BatHit.wav";
	description		= AudioClosest3d;
	preload			= true;
};

//PING! Loud echoey sound from the Super Smash Bros Series Homerun bat.
datablock AudioProfile(HomerunBatSuperHitSound)
{
	filename		= "./Ping.wav";
	description 	= AudioClose3d;
	preload			= true;
};

//6 notes of some song I hear in stuff related to baseball, and I have no idea what it's called.
datablock AudioProfile(HomerunBatHomerunSound)
{
	filename	    = "./Homerun.wav";
	description		= AudioClose3d;
	preload 		= true;
};

//Particle Datablocks
//A sparkle effect for the charge up.
datablock ParticleData(HomerunBatFlashParticle)
{
	dragCoefficient			= 3;
	gravityCoefficient		= -0.5;
	inheritedVelFactor		= 1;
	constantAcceleration	= 0.0;

	lifetimeMS				= 45;
	lifetimeVarianceMS		= 30;

	textureName				= "base/lighting/flare"; //HOLY CRAP IT'S NOT IN THE PARTICLES FOLDER!

	spinSpeed				= 40.0;
	spinRandomMin			= -500.0;
	spinRandomMax			= 500.0;

	colors[0]				= "0.9 0.9 0.9 0.5";
	colors[1]				= "0.3 0.3 1.0 1.0";
	colors[2]				= "0.9 0.5 0.0 0.1";
	sizes[0]				= 0.4;
	sizes[1]				= 1.5;
	sizes[2]				= 4.0;
	times[0]				= 0;
	times[1]				= 0.4;
	times[2]				= 1;

	useInvAlpha 			= false;
};

datablock ParticleEmitterData(HomerunBatFlashEmitter)
{
	ejectionPeriodMS	= 15;
	periodVarianceMS	= 10;
	ejectionVelocity	= 0.0;
	velocityVariance	= 0.0;
	ejectionOffset		= 0.9;
	thetaMin			= 0;
	thetaMax			= 180;
	phiReferenceVel		= 0;
	phiVariance		 	= 360;
	overrideAdvance		= false;
	particles			= "HomerunBatFlashParticle";

	uiName				= "Homerun Bat Twinkle";
};

//Explosion Datablock
datablock ExplosionData(HomerunBatExplosion)
{
	lifeTimeMS			= 500;

	soundProfile		= HomerunBatHitSound; //Add our cool sound effect. When you score a homerun kill with this, you're actually hearing all 3 sounds at once.

	particleEmitter		= swordExplosionEmitter; //No point in creating a new emitter. 
	particleDensity		= 10;
	particleRadius		= 0.4;

	faceViewer			= true;
	explosionScale		= "1 1 1";

	shakeCamera			= true;
	camShakeFreq		= "20.0 22.0 20.0";
	camShakeAmp			= "3.0 6.0 3.0";
	camShakeDuration	= 0.5;
	camShakeRadius		= 6.0;
};

//Projectile Datablocks
//Normal hit. When you're moving or you let go before fully charging.
datablock ProjectileData(HomerunBatProjectile)
{
	directDamage		= 12; //A simple hit won't do much.
	explosion			= HomerunBatExplosion;

	muzzleVelocity		= 70;
	velInheritFactor	= 1;

	armingDelay			= 0;
	lifetime			= 100;
	fadeDelay			= 70;

	bounceElasticity	= 0;
	bounceFriction		= 0;
	isBallistic			= false;
	gravityMod			= 0.0;

	hasLight			= false;

	uiName				= "Homerun Bat Whack";
};

//Super Projectile. Will knock them out of the park! 
datablock ProjectileData(HomerunBatSuperProjectile)
{
	directDamage		= 600;
	explosion			= HomerunBatExplosion;

	muzzleVelocity		= 70;
	velInheritFactor	= 1;

	armingDelay			= 0;
	lifetime			= 100;
	fadeDelay			= 70;

	bounceElasticity	= 0;
	bounceFriction		= 0;
	isBallistic			= false;
	gravityMod			= 0.0;

	hasLight			= false;

	uiName				= "Homerun Bat Homerun";
};

//Item Datablock
datablock ItemData(HomerunBatItem)
{
	category			= "Weapon";
	className			= "Weapon";

	shapeFile			= "./hrbat.dts";
	mass				= 1;
	density				= 0.2;
	elasticity			= 0.2;
	friction			= 0.6;
	emap				= true;

	uiName				= "Homerun Bat";
	iconName			= "./Icon_HomerunBat";

	image				= HomerunBatImage;
	canDrop				= true;
};

//Image Datablock
datablock ShapeBaseImageData(HomerunBatImage)
{
	shapeFile				= "./hrbat.dts";
	emap					= true;

	mountPoint				= 0;
	offset					= "0 0 0";
	correctMuzzleVector		= false;
	eyeOffset				= 0;

	className				= "WeaponImage";

	item					= HomerunBatItem;
	ammo					= " ";
	projectile				= HomerunBatProjectile;
	projectileType			= Projectile;

	melee					= true;
	doRetraction			= false;
	armReady				= true;

	stateName[0]						= "Activate";
	stateTimeoutValue[0]				= 0.1;
	stateTransitionOnTimeout[0]			= "Ready";
	stateSound[0]						= weaponSwitchSound;

	stateName[1]						= "Ready";
	stateTransitionOnTriggerDown[1]		= "AmmoCheck";
	stateScript[1]						= "ClearAmmo";
	stateAllowImageChange[1]			= true;

	stateName[2]						= "AmmoCheck";
	stateTransitionOnNoAmmo[2]			= "FireMinor";
	StateTransitionOnAmmo[2]			= "Charge";

	stateName[3]						= "Charge";
	stateTransitionOnTimeout[3]			= "FireMajor";
	stateScript[3]						= "onStopFire";
	stateTimeoutValue[3]				= 1.2;
	stateWaitForTimeout[3]				= false;
	stateEmitter[3]						= HomerunBatFlashEmitter;
	stateEmitterTime[3]					= 1.2;
	stateEmitterNode[3]					= "muzzleNode";
	stateTransitionOnTriggerUp[3]		= "FireMinor";
	stateAllowImageChange[3]			= false;

	stateName[4]						= "FireMinor";
	stateTransitionOnTimeout[4]			= "TriggerCheck";
	stateTimeoutValue[4]				= 0.2;
	stateWaitForTimeout[4]				= true;
	stateScript[4]						= "onFireMinor";
	stateSequence[4]					= "Fire";
	stateAllowImageChange[4]			= false;

	stateName[5]						= "TriggerCheck";
	stateTransitionOnTriggerDown[5]		= "AmmoCheck";
	stateTransitionOnTriggerUp[5]		= "StopFire";

	stateName[6]						= "FireMajor";
	stateTransitionOnTimeout[6]			= "Ready";
	stateTimeoutValue[6]				= 0.5;
	stateFire[6]						= true;
	stateScript[6]						= "onFireMajor";
	stateSequence[6]					= "Fire";
	stateWaitForTimeout[6]				= true;
	stateAllowImageChange[6]			= false;

	stateName[7]						= "StopFire";
	stateScript[7]						= "onStopFire";
	stateTimeout[7]						= 0.1;
	stateWaitForTimeout[7]				= true;
	stateTransitionOnTimeout[7]			= "Ready";
	stateAllowImageChange[7]			= false;
};

package HRBat
{
	function armor::onTrigger(%this,%player,%slot,%val)
	{
		if(%slot $= 4 && %player.getMountedImage(0) $= HomerunBatImage.getID() && %player.getImageTrigger(0))
		{
			if(%val)
			{
				%player.HRBatTrigEnable = getSimTime();
			}
			else
			{
				if(vectorDist(%player.HRBatTrigEnable,getSimTime()) < 500)
					%player.setImageAmmo(0,1);
			}
		}
		else
			Parent::onTrigger(%this,%player,%slot,%val);
	}
};
ActivatePackage(HRBat);
//State Scripts
function HomerunBatImage::ClearAmmo(%this, %obj, %slot) //So Jetting normally dosen't mean we trigger this.
{
		%obj.setImageAmmo(0, 0);
}

//Old method for super attack follows.
//function HomerunBatImage::onVelocityCheck(%this, %obj, %slot) //So we can determine if he's moving.
//{
//	if((mAbs(getWord(%obj.getvelocity(), 0)) + mAbs(getWord(%obj.getvelocity(), 1)) + mAbs(getWord(%obj.getvelocity(), 2)) / 3) <= 0.1) //In a nutshell, if he's not moving.
//	{
//		%obj.setImageAmmo(0, 1); //The Ammo hack for controlling a mounted image through script.
//		%obj.batPos = %obj.getPosition(); //In case they move, we'll be able to tell.
//	}
//	else
//		%obj.setImageAmmo(0, 0);
//}

function HomerunBatImage::onFireMinor(%this, %obj, %slot) //Just a bonk when firing normally.
{
	%obj.playthread(2, armAttack);
	%projectile = HomerunBatProjectile;
	%vector = %obj.getEyeVector();
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getEyePoint();
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	return %p;
}


function HomerunBatImage::onFireMajor(%this, %obj, %slot) //Batta Swing!
{
	%obj.playthread(2, shiftdown); //Again, the rest is just firing.
	%projectile = HomerunBatSuperProjectile;
	%vector = %obj.getEyeVector();
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getEyePoint();
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	return %p;
}

function HomerunBatImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root); //Stop the animation.
}

//Projectile Script
//How we detect if it's time to execute the homerun.
function HomerunBatSuperProjectile::Damage(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%this.directDamage <= 0)
		return;

	%damageType = $DamageType::Direct;
	if(%this.DirectDamageType)
		%damageType = %this.DirectDamageType;

	%scale = getWord(%obj.getScale(), 2);
	%directDamage = %this.directDamage * %scale;
	%col.damage(%obj, %pos, %directDamage, %damageType);
	//Do everything that's supposed to happen here, minus the part where we cap damage at 100...
	serverPlay3d(HomerunBatSuperHitSound, %pos); //PING! Epic sound effect from the SSB series.
	if(%col.isDisabled()) //Time For Fun
	{
		%velocity = vectorScale(%obj.client.player.getEyeVector(), 35); //Send him in the right direction
		%velocity = VectorAdd(%velocity, "0 0 45"); //A little height for homerunniness
		%col.setVelocity(%velocity); //Out of the park
		%col.mountImage(HomerunnedImage, 0); //Cool trail effect, too.
		if(getRandom(1, 50) == 37)
			serverPlay3d(HomerunBatHomerunSound, %pos); //Funny jingle I don't know the name of as an easter egg.
	}
}

//Homerun Trail effect that looks cool

//Particle Datablocks
//White Smoke Trail.
datablock ParticleData(HomerunnedParticle)
{
	dragCoefficient			= 6.0;
	gravityCoefficient		= 0.0;
	inheritedVelFactor		= 0.0;
	constantAcceleration	= 0.0;

	lifetimeMS				= 2400;
	lifetimeVarianceMS		= 250;

	useInvAlpha				= true;

	textureName				= "base/data/particles/cloud";

	colors[0]				= "1.0 1.0 1.0 1.0";
	colors[1]				= "0.9 0.9 0.9 0.0";
	sizes[0]				= 3;
	sizes[1]				= 6;
}; //We needn't bother with times values since there are only two colors and sizes.

datablock ParticleEmitterData(HomerunnedEmitter)
{
	ejectionPeriodMS	= 3;
	periodVarianceMS	= 0;
	ejectionVelocity	= 0;
	ejectionOffset		= 0.5;
	velocityVariance	= 0;
	thetaMin			= 0;
	thetaMax			= 180;
	phiReferenceVel		= 0;
	phiVariance			= 360;

	overrideAdvance		= false;

	particles			= "HomerunnedParticle";
};

//Image Datablock
datablock ShapeBaseImageData(HomerunnedImage)
{
	shapeFile			= "base/data/shapes/empty.dts";
	emap				= false;

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "FireA"; //We're only putting this on a corpse, so no need to send us to an unmount script.
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 1000;
	stateEmitter[1]					= HomerunnedEmitter;
	stateEmitterTime[1]				= 1000;
};